from 臺灣言語工具.音標系統.閩南語.臺灣閩南語羅馬字拼音 import 臺灣閩南語羅馬字拼音
from 臺灣言語工具.基本物件.詞 import 詞


def 是名詞(詞分詞):
    集合 = ('山｜suann1',)
    return 詞分詞 in 集合


def 是方位詞(詞分詞):
    集合 = ('後-壁｜au7-piah4', '上｜siong7', '頂｜ting2', '下｜e7', '外｜gua7')
    return 詞分詞 in 集合


def 方位詞原則(句物件):
    錯誤訊息陣列 = []
    詞物件陣列 = 句物件.網出詞物件()
    前一个詞分詞 = None
    累積字長度 = 0
    for 詞物件 in 詞物件陣列:
        詞分詞 = 詞物件.轉音(臺灣閩南語羅馬字拼音).看分詞()
        字物件陣列 = 詞物件.篩出字物件()
        詞長度 = len(字物件陣列)
        結尾雙音節分詞 = 詞(字物件陣列[-2:]).轉音(臺灣閩南語羅馬字拼音).看分詞()
        前半段分詞 = 詞(字物件陣列[:-2]).轉音(臺灣閩南語羅馬字拼音).看分詞()

        # 名詞和單音節方位詞應連寫 山頂 => 山-頂
        if 前一个詞分詞 and 是名詞(前一个詞分詞) and 是方位詞(詞分詞) and 詞長度 == 1:
            錯誤行數 = 累積字長度 + 1
            錯誤連字符位置 = '前'
            錯誤訊息陣列.append(('E名詞（三）', 錯誤行數, 錯誤連字符位置))

        # 名詞和多音節方位詞應連寫 山-後-壁 => 山 後-壁
        # Note: 目前暫定只處理雙音節
        elif 是名詞(前半段分詞) and 是方位詞(結尾雙音節分詞) and 詞長度 > 2:
            錯誤行數 = 累積字長度 + 詞長度 - 1
            錯誤連字符位置 = '前'
            錯誤訊息陣列.append(('E名詞（三）', 錯誤行數, 錯誤連字符位置))
        前一个詞分詞 = 詞分詞
        累積字長度 += 詞長度
    return 錯誤訊息陣列
